#! /usr/bin/perl

# The contents of this file are subject to the Netscape Public License
# Version 1.0 (the "License"); you may not use this file except in
# compliance with the License.  You may obtain a copy of the License at
# http://www.mozilla.org/NPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See
# the License for the specific language governing rights and limitations
# under the License.
#
# The Original Code is Mozilla Communicator client code.
#
# The Initial Developer of the Original Code is Netscape Communications
# Corporation.  Portions created by Netscape are Copyright (C) 1998
# Netscape Communications Corporation.  All Rights Reserved.

######################################################################

# use a prefix to avoid conflicts like int (integral), union
$prefix = "";

# Table of tag names; it doesn't have to be sorted because code
# below will do it. However, for the sake of ease of additions, keep
# it sorted so that its easy to tell where to add a new tag and that
# the tag hasn't already been added.
$i = 0; 

$tags[$i++] = "a";
$tags[$i++] = "actuate";
$tags[$i++] = "allow-zoom-and-pan";
$tags[$i++] = "angle";
$tags[$i++] = "circle";
$tags[$i++] = "class";
$tags[$i++] = "color";
$tags[$i++] = "content";
$tags[$i++] = "cx";
$tags[$i++] = "cy";
$tags[$i++] = "d";
$tags[$i++] = "data";
$tags[$i++] = "defs";
$tags[$i++] = "desc";
$tags[$i++] = "ellipse";
$tags[$i++] = "flatness";
$tags[$i++] = "foreignobject";
$tags[$i++] = "g";
$tags[$i++] = "gradientstop";
$tags[$i++] = "height";
$tags[$i++] = "href";
$tags[$i++] = "id";
$tags[$i++] = "image";
$tags[$i++] = "innermost-x";
$tags[$i++] = "innermost-y";
$tags[$i++] = "lang";
$tags[$i++] = "line";
$tags[$i++] = "lineargradient";
$tags[$i++] = "major";
$tags[$i++] = "marker";
$tags[$i++] = "matrix";
$tags[$i++] = "max-x";
$tags[$i++] = "max-y";
$tags[$i++] = "min-x";
$tags[$i++] = "min-y";
$tags[$i++] = "minor";
$tags[$i++] = "namespace";
$tags[$i++] = "nominal-length";
$tags[$i++] = "offset";
$tags[$i++] = "onclick";
$tags[$i++] = "ondblclick";
$tags[$i++] = "onkeydown";
$tags[$i++] = "onkeypress";
$tags[$i++] = "onkeyup";
$tags[$i++] = "onload";
$tags[$i++] = "onmousedown";
$tags[$i++] = "onmousemove";
$tags[$i++] = "onmouseout";
$tags[$i++] = "onmouseover";
$tags[$i++] = "onmouseup";
$tags[$i++] = "onselect";
$tags[$i++] = "onunload";
$tags[$i++] = "onzoom";
$tags[$i++] = "outermost-radius";
$tags[$i++] = "outermost-x";
$tags[$i++] = "outermost-y";
$tags[$i++] = "path";
$tags[$i++] = "polygon";
$tags[$i++] = "polyline";
$tags[$i++] = "private";
$tags[$i++] = "r";
$tags[$i++] = "radialgradient";
$tags[$i++] = "rect";
$tags[$i++] = "ref-x";
$tags[$i++] = "ref-y";
$tags[$i++] = "script";
$tags[$i++] = "show";
$tags[$i++] = "sides";
$tags[$i++] = "spread-method";
$tags[$i++] = "src";
$tags[$i++] = "start-offset";
$tags[$i++] = "str_text";
$tags[$i++] = "style";
$tags[$i++] = "svg";
$tags[$i++] = "switch";
$tags[$i++] = "symbol";
$tags[$i++] = "system_required";
$tags[$i++] = "t";
$tags[$i++] = "target-bottom";
$tags[$i++] = "target-left";
$tags[$i++] = "target-right";
$tags[$i++] = "target-top";
$tags[$i++] = "target-type";
$tags[$i++] = "text";
$tags[$i++] = "textflow";
$tags[$i++] = "textpath";
$tags[$i++] = "tf";
$tags[$i++] = "title";
$tags[$i++] = "use";
$tags[$i++] = "vector-angle";
$tags[$i++] = "vector-length";
$tags[$i++] = "vector-start-x";
$tags[$i++] = "vector-start-y";
$tags[$i++] = "verts";
$tags[$i++] = "width";
$tags[$i++] = "x";
$tags[$i++] = "x1";
$tags[$i++] = "x2";
$tags[$i++] = "xml:lang";
$tags[$i++] = "xml:link";
$tags[$i++] = "y";
$tags[$i++] = "y1";
$tags[$i++] = "y2";


######################################################################

# Sort the tag table before using it
@tags = sort @tags;

$copyright = "/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the \"License\"); you may not use this file except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an \"AS IS\"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of this code under the NPL is CALM Group,
 * Heriot-Watt University, Edinburgh. Portions created by Heriot-Watt are
 * Copyright (C) 1999 Heriot-Watt University, Edinburgh.  All Rights
 * Reserved.
 */

/* Do not edit - generated by gentags.pl */
";

######################################################################

$file_base = $ARGV[0];

# First stage: Generate the header file
######################################################################

open(HEADER_FILE, ">$file_base.h");
print HEADER_FILE $copyright;
print HEADER_FILE "
#ifndef nsSVGAtoms_h___
#define nsSVGAtoms_h___

#include \"prtypes.h\"
#include \"nsIAtom.h\"

class nsINameSpaceManager;

/**
 * This class wraps up the creation and destruction of the standard
 * set of SVG atoms used during normal SVG handling. This object
 * is created when the first SVG content object is created, and
 * destroyed when the last such content object is destroyed.
 */
class nsSVGAtoms {
public:

  static void AddrefAtoms();
  static void ReleaseAtoms();

  // SVG namespace ID, good for the life of the nsSVGAtoms object
  static PRInt32  nameSpaceID;

  // Alphabetical list of SVG tag and attribute atoms
";

for ($j = 0; $j < $i; $j++) {
    $lower = $tags[$j];
    $lower =~ tr/A-Z/a-z/;
    print HEADER_FILE "  static nsIAtom* $prefix$lower;\n";
}

print HEADER_FILE "
};

#endif /* nsSVGAtoms_h___ */
";

close(HEADER_FILE);


# Second stage: Generate the cpp file
#####################################################################

open(CPP_FILE, ">$file_base.cpp");

# Print out copyright and do not edit notice
print CPP_FILE $copyright;

# Now dump the code 

print CPP_FILE "
#include \"nsString.h\"
#include \"nsINameSpaceManager.h\"
#include \"nsSVGAtoms.h\"

static const char kSVGNameSpace[] = \"http://www.w3.org/TR/REC-SVG\";

PRInt32  nsSVGAtoms::nameSpaceID;
";

for ($j = 0; $j < $i; $j++) {
    $lower = $tags[$j];
    $lower =~ tr/A-Z/a-z/;
    print CPP_FILE "nsIAtom* nsSVGAtoms::$prefix$lower;\n";
}


print CPP_FILE "
static nsrefcnt gRefCnt;
static nsINameSpaceManager* gNameSpaceManager;

void nsSVGAtoms::AddrefAtoms() {

  if (gRefCnt == 0) {
    /* SVG Atoms registers the SVG name space ID because it's a convenient
       place to do this, if you don't want a permanent, \"well-known\" ID.
    */
    if (NS_SUCCEEDED(NS_NewNameSpaceManager(&gNameSpaceManager)))
//    gNameSpaceManager->CreateRootNameSpace(namespace);
      gNameSpaceManager->RegisterNameSpace(kSVGNameSpace, nameSpaceID);
    else
      NS_ASSERTION(0, \"failed to create SVG atoms namespace manager\");

    // now register the atoms
";

for ($j = 0; $j < $i; $j++) {
    $lower = $tags[$j];
    $lower =~ tr/A-Z/a-z/;
    print CPP_FILE "    $prefix$lower = NS_NewAtom(\"$lower\");\n";
}

print CPP_FILE "
  }
  ++gRefCnt;
}

void nsSVGAtoms::ReleaseAtoms() {

  NS_PRECONDITION(gRefCnt != 0, \"bad release of SVG atoms\");
  if (--gRefCnt == 0) {
";  

for ($j = 0; $j < $i; $j++) {
    $lower = $tags[$j];
    $lower =~ tr/A-Z/a-z/;
    print CPP_FILE "    NS_RELEASE($prefix$lower);\n";
}

print CPP_FILE "
    NS_IF_RELEASE(gNameSpaceManager);
  }
}

";

close(CPP_FILE);
